/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett          - initial API and implementation
 *     Michael Fiedler      - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.it.bcm.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.it.bcm.servlet.ServletListener;
import se.kth.md.it.bcm.BugzillaCachedAdaptorConstants;
import se.kth.md.it.bcm.resources.Person;
import se.kth.md.it.bcm.resources.Person;
import se.kth.md.it.bcm.resources.Type;

// Start of user code imports
// End of user code

// Start of user code preClassCode
// End of user code

// Start of user code classAnnotations
// End of user code
@OslcNamespace(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE)
@OslcName(BugzillaCachedAdaptorConstants.BUGZILLACHANGEREQUEST)
@OslcResourceShape(title = "BugzillaChangeRequest Resource Shape", describes = BugzillaCachedAdaptorConstants.TYPE_BUGZILLACHANGEREQUEST)
public class BugzillaChangeRequest
    extends ChangeRequest
    implements IBugzillaChangeRequest
{

    // Start of user code attributeAnnotation:priority
    // End of user code
    private String priority;
    // Start of user code attributeAnnotation:platform
    // End of user code
    private String platform;
    // Start of user code attributeAnnotation:version
    // End of user code
    private String version;
    // Start of user code attributeAnnotation:component
    // End of user code
    private String component;
    // Start of user code attributeAnnotation:product
    // End of user code
    private String product;
    // Start of user code attributeAnnotation:operatingSystem
    // End of user code
    private String operatingSystem;

    // Start of user code classAttributes
    // End of user code

    // Start of user code classMethods
    // End of user code

    public BugzillaChangeRequest()
           throws URISyntaxException
    {
        super();

        // Start of user code constructor1
        // End of user code
    }

    public BugzillaChangeRequest(final URI about)
           throws URISyntaxException
    {
        super(about);

        // Start of user code constructor2
        // End of user code
    }

    public BugzillaChangeRequest(final String serviceProviderId, final String bugzillaChangeRequestId)
           throws URISyntaxException
    {
        this (constructURI(serviceProviderId, bugzillaChangeRequestId));
        // Start of user code constructor3
        // End of user code
    }

    public static URI constructURI(final String serviceProviderId, final String bugzillaChangeRequestId)
    {
        String basePath = ServletListener.getServicesBase();
        Map<String, Object> pathParameters = new HashMap<String, Object>();
        pathParameters.put("serviceProviderId", serviceProviderId);
        pathParameters.put("bugzillaChangeRequestId", bugzillaChangeRequestId);
        String instanceURI = "serviceProviders/{serviceProviderId}/bugzillaChangeRequests/{bugzillaChangeRequestId}";

        final UriBuilder builder = UriBuilder.fromUri(basePath);
        return builder.path(instanceURI).buildFromMap(pathParameters);
    }

    public static Link constructLink(final String serviceProviderId, final String bugzillaChangeRequestId , final String label)
    {
        return new Link(constructURI(serviceProviderId, bugzillaChangeRequestId), label);
    }

    public static Link constructLink(final String serviceProviderId, final String bugzillaChangeRequestId)
    {
        return new Link(constructURI(serviceProviderId, bugzillaChangeRequestId));
    }

    public String toString()
    {
        return toString(false);
    }

    public String toString(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toString_init
        // End of user code

        if (asLocalResource) {
            result = result + "{a Local BugzillaChangeRequest Resource} - update BugzillaChangeRequest.toString() to present resource as desired.";
            // Start of user code toString_bodyForLocalResource
            // End of user code
        }
        else {
            result = getAbout().toString();
        }

        // Start of user code toString_finalize
        // End of user code

        return result;
    }

    public String toHtml()
    {
        return toHtml(false);
    }

    public String toHtml(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toHtml_init
        // End of user code

        if (asLocalResource) {
            result = toString(true);
            // Start of user code toHtml_bodyForLocalResource
            // End of user code
        }
        else {
            result = "<a href=\"" + getAbout() + "\">" + toString() + "</a>";
        }

        // Start of user code toHtml_finalize
        // End of user code

        return result;
    }


    // Start of user code getterAnnotation:priority
    // End of user code
    @OslcName("priority")
    @OslcPropertyDefinition(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE + "priority")
    @OslcDescription("The Bugzilla priority for this change request.")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    @OslcTitle("Priority")
    public String getPriority()
    {
        // Start of user code getterInit:priority
        // End of user code
        return priority;
    }

    // Start of user code getterAnnotation:platform
    // End of user code
    @OslcName("platform")
    @OslcPropertyDefinition(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE + "platform")
    @OslcDescription("The Bugzilla platform for this change request.")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    @OslcTitle("Platform")
    public String getPlatform()
    {
        // Start of user code getterInit:platform
        // End of user code
        return platform;
    }

    // Start of user code getterAnnotation:version
    // End of user code
    @OslcName("version")
    @OslcPropertyDefinition(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE + "version")
    @OslcDescription("The Bugzilla version for this change request.")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(true)
    @OslcTitle("Version")
    public String getVersion()
    {
        // Start of user code getterInit:version
        // End of user code
        return version;
    }

    // Start of user code getterAnnotation:component
    // End of user code
    @OslcName("component")
    @OslcPropertyDefinition(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE + "component")
    @OslcDescription("The Bugzilla product definition for this change request.")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    @OslcTitle("Component")
    public String getComponent()
    {
        // Start of user code getterInit:component
        // End of user code
        return component;
    }

    // Start of user code getterAnnotation:product
    // End of user code
    @OslcName("product")
    @OslcPropertyDefinition(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE + "product")
    @OslcDescription("")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    public String getProduct()
    {
        // Start of user code getterInit:product
        // End of user code
        return product;
    }

    // Start of user code getterAnnotation:operatingSystem
    // End of user code
    @OslcName("operatingSystem")
    @OslcPropertyDefinition(BugzillaCachedAdaptorConstants.BUGZILLA_NAMSPACE + "operatingSystem")
    @OslcDescription("The Bugzilla operating system for this change request.")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    @OslcTitle("Operating System")
    public String getOperatingSystem()
    {
        // Start of user code getterInit:operatingSystem
        // End of user code
        return operatingSystem;
    }


    // Start of user code setterAnnotation:priority
    // End of user code
    public void setPriority(final String priority )
    {
        // Start of user code setterInit:priority
        // End of user code
        this.priority = priority;
        // Start of user code setterFinalize:priority
        // End of user code
    }

    // Start of user code setterAnnotation:platform
    // End of user code
    public void setPlatform(final String platform )
    {
        // Start of user code setterInit:platform
        // End of user code
        this.platform = platform;
        // Start of user code setterFinalize:platform
        // End of user code
    }

    // Start of user code setterAnnotation:version
    // End of user code
    public void setVersion(final String version )
    {
        // Start of user code setterInit:version
        // End of user code
        this.version = version;
        // Start of user code setterFinalize:version
        // End of user code
    }

    // Start of user code setterAnnotation:component
    // End of user code
    public void setComponent(final String component )
    {
        // Start of user code setterInit:component
        // End of user code
        this.component = component;
        // Start of user code setterFinalize:component
        // End of user code
    }

    // Start of user code setterAnnotation:product
    // End of user code
    public void setProduct(final String product )
    {
        // Start of user code setterInit:product
        // End of user code
        this.product = product;
        // Start of user code setterFinalize:product
        // End of user code
    }

    // Start of user code setterAnnotation:operatingSystem
    // End of user code
    public void setOperatingSystem(final String operatingSystem )
    {
        // Start of user code setterInit:operatingSystem
        // End of user code
        this.operatingSystem = operatingSystem;
        // Start of user code setterFinalize:operatingSystem
        // End of user code
    }


    static public String priorityToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:priorityToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"priority\">priority: </LABEL>";
    
        // Start of user code "Mid:priorityToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"priority\" type=\"text\" style=\"width: 400px\" id=\"priority\" >";
        // Start of user code "Finalize:priorityToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }

    static public String platformToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:platformToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"platform\">platform: </LABEL>";
    
        // Start of user code "Mid:platformToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"platform\" type=\"text\" style=\"width: 400px\" id=\"platform\" >";
        // Start of user code "Finalize:platformToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }

    static public String versionToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:versionToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"version\">version: </LABEL>";
    
        // Start of user code "Mid:versionToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"version\" type=\"text\" style=\"width: 400px\" id=\"version\" >";
        // Start of user code "Finalize:versionToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }

    static public String componentToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:componentToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"component\">component: </LABEL>";
    
        // Start of user code "Mid:componentToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"component\" type=\"text\" style=\"width: 400px\" id=\"component\" >";
        // Start of user code "Finalize:componentToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }

    static public String productToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:productToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"product\">product: </LABEL>";
    
        // Start of user code "Mid:productToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"product\" type=\"text\" style=\"width: 400px\" id=\"product\" >";
        // Start of user code "Finalize:productToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }

    static public String operatingSystemToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:operatingSystemToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"operatingSystem\">operatingSystem: </LABEL>";
    
        // Start of user code "Mid:operatingSystemToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"operatingSystem\" type=\"text\" style=\"width: 400px\" id=\"operatingSystem\" >";
        // Start of user code "Finalize:operatingSystemToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }


    public String priorityToHtml()
    {
        String s = "";

        // Start of user code prioritytoHtml_init
        // End of user code

        s = s + "<label for=\"priority\"><strong>priority</strong>: </LABEL>";

        // Start of user code prioritytoHtml_mid
        // End of user code

        try {
            if (priority == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + priority.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Start of user code prioritytoHtml_finalize
        // End of user code

        return s;
    }
    public String platformToHtml()
    {
        String s = "";

        // Start of user code platformtoHtml_init
        // End of user code

        s = s + "<label for=\"platform\"><strong>platform</strong>: </LABEL>";

        // Start of user code platformtoHtml_mid
        // End of user code

        try {
            if (platform == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + platform.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Start of user code platformtoHtml_finalize
        // End of user code

        return s;
    }
    public String versionToHtml()
    {
        String s = "";

        // Start of user code versiontoHtml_init
        // End of user code

        s = s + "<label for=\"version\"><strong>version</strong>: </LABEL>";

        // Start of user code versiontoHtml_mid
        // End of user code

        try {
            if (version == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + version.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Start of user code versiontoHtml_finalize
        // End of user code

        return s;
    }
    public String componentToHtml()
    {
        String s = "";

        // Start of user code componenttoHtml_init
        // End of user code

        s = s + "<label for=\"component\"><strong>component</strong>: </LABEL>";

        // Start of user code componenttoHtml_mid
        // End of user code

        try {
            if (component == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + component.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Start of user code componenttoHtml_finalize
        // End of user code

        return s;
    }
    public String productToHtml()
    {
        String s = "";

        // Start of user code producttoHtml_init
        // End of user code

        s = s + "<label for=\"product\"><strong>product</strong>: </LABEL>";

        // Start of user code producttoHtml_mid
        // End of user code

        try {
            if (product == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + product.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Start of user code producttoHtml_finalize
        // End of user code

        return s;
    }
    public String operatingSystemToHtml()
    {
        String s = "";

        // Start of user code operatingSystemtoHtml_init
        // End of user code

        s = s + "<label for=\"operatingSystem\"><strong>operatingSystem</strong>: </LABEL>";

        // Start of user code operatingSystemtoHtml_mid
        // End of user code

        try {
            if (operatingSystem == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + operatingSystem.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Start of user code operatingSystemtoHtml_finalize
        // End of user code

        return s;
    }
}
